'use strict';

const URL = require('url');
const https = require('https');
const http = require('http');
const Promise = require('../modules/bluebird');

class Enum {
  constructor() {
    console.log('123');
    Promise.promisifyAll(this, {
      filter: function() {
        return true;
      }
    });
  }

  _formatHost(host) {
    let res = host;
    if (host.toLowerCase().indexOf('http://') === 0) {
      res = host;
    } else if (host.toLowerCase().indexOf('https://') === 0) {
      res = host;
    } else {
      res = 'http://' + host;
    }

    if (res[res.length - 1] === '/') {
      return res;
    } else {
      return res + '/';
    }
  }

  _isHttp(host) {
    if (host.toLowerCase().indexOf('http://') === 0) {
      return true;
    }
    return false;
  }

  _getHeaderByName(name, headers) {
    for (let i = 0; i < headers.length; i += 2) {
      if (i >= headers.length) {
        break;
      }
      if (headers[i] !== name) {
        continue;
      }
      i++;
      if (i >= headers.length) {
        break;
      }
      return headers[i];
    }
    return null;
  }


  _getRealHostName(host, timeout, cb) {
    let getter = https;
    if (this._isHttp(host)) {
      getter = http;
    }

    let timeoutID;

    try {
      let req = getter.get(host, res => {
        res.socket.end();
        res.socket.destroy();
        let location = this._getHeaderByName('Location', res.rawHeaders);
        let oldHost = host;
        if (location) {
          host = URL.resolve(host, location);
        }
        clearTimeout(timeoutID);
        cb(null, host);
        cb = function() {};
      }).on('error', function(e) {
        console.log('error');
        console.log(e);

        clearTimeout(timeoutID);
	console.log('calling cb');
        cb(e);
	console.log('done');
        cb = function() {};
      });

      timeoutID = setTimeout(() => {
        req.abort();
        cb('timeout');
        cb = function() {};
      }, timeout);

    } catch (e) {
      console.log(e);
      cb(e);
      cb = Function.prototype;
    }
  }

  _searchInLocation(location) {
    if (!location) {
      return null;
    }
    //  console.log(location);
    const arr = location.split('/');
    for (let i = 0; i < arr.length; i++) {
      const item = arr[i];
      if (item === 'author') {
        if (i < arr.length - 1) {
          const result = arr[i + 1];
          if (result.indexOf('"') !== -1) {
            return null;
          }
          return result;
        }
      }
    }
    return null;
  }

  _extract_between(content, start, end) {
    if (!content) {
      return null;
    }
    let a = content.indexOf(start);
    if (a == -1) {
      return null;
    }
    a += start.length;
    a = content.substring(a);

    let z = a.indexOf(end);
    if (z == -1) {
      return null;
    }
    let res = a.substring(0, z);
    return res;
  }


  _searchInSource(source) {
    //user=`curl --max-time 7  -L  "$1"/?author=1 |grep -a "/author/" |grep -a  feed |awk -F '/author/' '{print $2}' |awk -F '/' '{print $1}'`

    let res = this._extract_between(source, '/author/', '/feed');
    console.log(res);
    if (!res) {
      console.log('no res');
      let ind1 = source.indexOf('/author/');
      console.log(ind1);
      let ind2 = source.indexOf('/feed/');
      console.log(ind2);
      return null;
    }
    let index = res.indexOf('"');
    if (index !== -1) {
      res = res.substring(0, index);
    }
    index = res.indexOf('/');
    if (index !== -1) {
      res = res.substring(0, index);
    }

    index = res.indexOf('\'');
    if (index !== -1) {
      res = res.substring(0, index);
    }

    index = res.indexOf('<');
    if (index !== -1) {
      res = res.substring(0, index);
    }

    index = res.indexOf('>');
    if (index !== -1) {
      res = res.substring(0, index);
    }

    return res;
  }

  _getAuthorName(location, content, cb) {
    console.log('getting author name');
    console.log(location);
    if (!location && content) {
      let names = this._extractNamesFromSource(content);
      let names1 = this._extractNamesFromTitle(content);
      names = names.concat(names1);
      names = Array.from(new Set(names));
      process.nextTick(() => {
        cb(null, names);
      });
      return;
    }

    if (!location && !content) {
      cb(null, []);
      return;
    }

    let protocol = https;
    if (location.indexOf('http://') === 0) {
      protocol = http;
    }

    try {
      console.log('getting author name: %s', location);
      const req = protocol.get(location, resp => {
        let data = '';
        resp.on('data', d => {
          data += d.toString();
        });
        resp.on('end', () => {
          console.log('done');
          let names = this._extractNamesFromSource(data);
          let names1 = this._extractNamesFromTitle(data);
          names = names.concat(names1);
          names = Array.from(new Set(names));
          cb(null, names);
        });
      });

      req.on('error', err => {
        cb(null, []);
        cb = Function.prototype;
      });
    } catch (e) {
      console.log(e);
      cb(null, []);
      cb = Function.prototype;
    }
  }

  _isASCII(str){
    if(typeof(str)!=='string'){
      return false;
    }
    for(var i=0;i<str.length;i++){
      if(str.charCodeAt(i)>127){
        return false;
      }
    }
    return true;
  }


  _extractNamesFromTitle(source) {
    const resultSet = new Set();
    let start = source.indexOf('<title>');
    if (start === -1) {
      return [];
    }
    start += '<title>'.length;
    source = source.substring(start);
    const end = source.indexOf('</title>');
    if (end === -1) {
      return [];
    }
    source = source.substring(0, end);
    if (source.indexOf('\n') !== -1) {
      return -1;
    }
    const arr = source.split(' ');
    for (const word of arr) {
      if (!this._isASCII(word)) {
        continue;
      }
      if (word.length < 4) {
        continue;
      }
      resultSet.add(word);
    }
    const result = Array.from(resultSet);
    console.log('title:');
    console.log(source);
    console.log(result);
    return result;
  }

  _extractNamesFromSource(source) {
    const arr = source.split('\n');
    const resultSet = new Set();
    for (const line of arr) {
      if (line.indexOf('feed') === -1) {
        continue;
      }
      if (line.indexOf('author') === -1) {
        continue;
      }
      const str = this._extract_between(line, 'title="', '"');
      if (!str) {
        continue;
      }
      const arr1 = str.split(' ');
      for (const word of arr1) {
        if (!this._isASCII(word)) {
          continue;
        }
        if (word.length < 4) {
          continue;
        }
        resultSet.add(word);
      }
    }
    const result = Array.from(resultSet);
    console.log(result);
    return result;
  }

  _checkByNumber(host, num, cb) {
    let getter = https;
    if (this._isHttp(host)) {
      getter = http;
    }

    if (host[host.length - 1] === '/') {
      host = host.substring(0, host.length - 1);
    }

    let url = host + '?author=' + num;

    try {
      let req = getter.get(url, res => {
        let location = this._getHeaderByName('Location', res.rawHeaders);
        let result = this._searchInLocation(location);
        if (result) {
          console.log('location result: %s', result);
        }
        let content = '';
        console.log(res.statusCode);
        res.on('data', chunk => {
          content += chunk.toString();
        });
        res.on('end', () => {
          if (!result) {
            result = this._searchInSource(content);
          }
          if (!result) {
            cb(null, null);
            cb = Function.prototype;
          }
          this._getAuthorName(location, content, (err, authors) => {
            cb(null, {
              user: result,
              names: authors
            });
          });
        });
      });

      req.on('error', e => {
        console.log('request error');
        console.log(e);
        cb(e);
        cb = Function.prototype;
      });
    } catch (e) {
      cb(null, []);
      cb = Function.prototype;
    }

  }

  _testExploit(host, cb) {
    let getter = https;
    if (this._isHttp(host)) {
      getter = http;
    }
    if (host[host.length - 1] === '/') {
      host = host.substring(0, host.length - 1);
    }

    host += '/wp-json/wp/v2/users/';
    console.log(host);
    try {
      const req = getter.get(host, resp => {
        let data = '';
        resp.on('data', d => {
          data += d.toString();
        });
        resp.on('end', () => {
          console.log(data);
          let parsed = null;
          try {
            parsed = JSON.parse(data);
          } catch(e) {
            console.log(data);
            console.log('can not parse');
          }
          if (!parsed) {
            cb(null, null);
            return;
          }
          if (!Array.isArray(parsed)) {
            cb(null, null);
            return;
          }
          if (parsed.length === 0) {
            cb(null, null);
            return;
          }
          //      console.log(parsed[0]);
          const arr = [];
          for (const user of parsed) {
            arr.push({
              user: user['slug'],
              names: [user['name']]
            });
            console.log(user['id'] + ') ' + user['name'] + '; ' + user['slug']);
          }
          cb(null, arr);
        });
      });
      req.on('error', e => {
        cb(e);
      });
    } catch (e) {
      cb(null, []);
      cb = Function.prototype;
      return;
    }

  }


  enum(host, start, end, timeout, cb) {
    console.log('enuming: %s %s %s %s', host, start, end, timeout);
    host = this._formatHost(host);
    const startTime = new Date();

    let oldHost = host;
    this._getRealHostNameAsync(host, timeout)
      .then(resp => {
        console.log('host was: %s, became: %s', host, resp);
	host = resp;
	return this._testExploitAsync(host);
      })
      .then(users => {
	if (users) {
	  cb(null, users);
	  return;
	}

        const arr = [];
        for (let i = start; i < end; i++) {
          arr.push(i);
        }
        let done = false;
        let stop = false;
        const now = new Date();
        const result = [];
        Promise.each(arr, (item, index, length) => {
          if (stop) {
            return false;
          }
          if (done) {
            return false;
          }
          const diff = new Date().getTime() - now.getTime();
          console.log('checking: %s %s. diff is: %d', host, item, diff / 1000);
          return this._checkByNumberAsync(host, item)
            .then(resp => {
              console.log('resp is: %s', resp);
              if (!resp) {
                stop = true;
                return;
              }
              result.push(resp);
            });
        })
	  .then(resp => {
	    const d = timeout - (new Date().getTime() - startTime.getTime());
	    console.log('setting timeout: %s', d);
	  })
          .timeout(timeout - (new Date().getTime() - startTime.getTime()))
          .catch(Promise.TimeoutError, err => {
            console.log('timeout happened');
            stop = true;
          })
	  .catch(err => {
	    console.log(err);
	    stop = true;
	  })
          .then(resp => {
            done = true;
            console.log('done123');
            console.log(result);
	    cb(null, result);
          });
      })
      .then(resp => {
	const d = timeout - (new Date().getTime() - startTime.getTime());
	console.log('setting timeout: %s', d);
      })
      .timeout(timeout - (new Date().getTime() - startTime.getTime()))
      .catch(Promise.TimeoutError, err => {
	cb(null, []);
      })
      .catch(err => {
	cb(null, []);
      });



  }


};


module.exports = Enum;
